package chembal;

import java.sql.*;
import java.util.*;

/**
 * <p>
 * Title: ChemBal
 * </p>
 *
 * <p>
 * Description: Balances Chemical Equations
 * </p>
 *
 * <p>
 * Copyright: Copyright (c) 2003
 * </p>
 *
 * <p>
 * Company:
 * </p>
 *
 * @author jeremyd
 * @version 1.0
 */
public class ElementDataConnector
{
	private static Connection con;
	private static Statement stmt;
	private static Map htSym2Num;
	private static Map htNum2ED;
        private static final String dbDrv = "org.hsqldb.jdbcDriver"; //"sun.jdbc.odbc.JdbcOdbcDriver"
        private static final String dbUrl = "jdbc:hsqldb:db/periodic"; //"jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};Dbq=d:\\documents and settings\\jeremyd\\my documents\\periodic.mdb"
        private static final String dbUsr = "sa";
        private static final String dbPass = "";

	static
	{
		try
		{
			htSym2Num = new HashMap();
			htNum2ED = new HashMap();
			Class.forName(dbDrv);
			con = DriverManager.getConnection(dbUrl, dbUsr, dbPass);
			stmt = con.createStatement();
			ResultSet rs = stmt.executeQuery("SELECT * FROM Periodic");

			while (rs.next())
			{
				Integer an = new Integer(rs.getInt("ID"));
				String sym = rs.getString("Symbol");
				String name = rs.getString("AtomName");
				double aw = rs.getDouble("AtomWeight");
				htSym2Num.put(sym, an);
				ElementData eld = new ElementData(an, sym, name, aw);
				htNum2ED.put(an, eld);
			}

			rs.close();
			stmt.close();
			con.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	static ElementData getED(String symbol)
	{
		return (ElementData) htNum2ED.get(htSym2Num.get(symbol));
	}
}
